<?php 

class gruveo_widget extends WP_Widget {

	/**
	 * Register widget with WordPress.
	 */
	public function __construct() {
		parent::__construct(
	 		'gruveo_widget', // Base ID
			'Video Call Button by Gruveo', // Name
			array( 'description' => __( 'A Gruveo click-to-call button.', 'wgc' ), ) // Args
		);
	}

	public function widget( $args, $instance ) {
		extract( $args );
		$title = apply_filters( 'widget_title', $instance['title'] );
		$handle = apply_filters( 'widget_title', $instance['handle'] );
		$large_button = apply_filters( 'widget_title', $instance['large_button'] );
		$show_handle = apply_filters( 'widget_title', $instance['show_handle'] );
		$language = apply_filters( 'widget_title', $instance['language'] );
		$button_size = apply_filters( 'widget_title', $instance['button_size'] );
		$button_type = apply_filters( 'widget_title', $instance['button_type'] );

		echo $before_widget;
		if ( ! empty( $title ) )
			echo $before_title . $title . $after_title;
			
			if (preg_match('/^@[a-zA-Z0-9]+(?:\.[a-zA-Z0-9]+)*$/', $handle)) {
				echo wgc_generate_button( $handle, $large_button, $language, $button_size, $button_type );
			}
		
		echo $after_widget;
	}

	public function update( $new_instance, $old_instance ) {
		$instance = array();
		$instance['title'] = strip_tags( $new_instance['title'] );
		$instance['handle'] = strip_tags( $new_instance['handle'] );
		$instance['large_button'] = strip_tags( $new_instance['large_button'] );
		$instance['show_handle'] = strip_tags( $new_instance['show_handle'] );
		$instance['language'] = strip_tags( $new_instance['language'] );
		$instance['button_size'] = strip_tags( $new_instance['button_size'] );
		$instance['button_type'] = strip_tags( $new_instance['button_type'] );

		return $instance;
	}

	public function form( $instance ) {
		if ( isset( $instance[ 'title' ] ) ) {
			$title = $instance[ 'title' ];
			
		}
		$handle = $instance[ 'handle' ];
		$large_button = $instance[ 'large_button' ];
		$show_handle = $instance[ 'show_handle' ];
		$language = $instance[ 'language' ];
		$button_size = $instance[ 'button_size' ];
		$button_type = $instance[ 'button_type' ];
		?>
		<p>
		<label for="<?php echo $this->get_field_id( 'title' ); ?>"><?php _e( 'Title:' ); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id( 'title' ); ?>" name="<?php echo $this->get_field_name( 'title' ); ?>" type="text" value="<?php echo esc_attr( $title ); ?>" />
		</p>
		<p>
		<label for="<?php echo $this->get_field_id( 'handle' ); ?>"><?php _e( 'Gruveo handle:' ); ?></label> 
		<input class="widefat" id="<?php echo $this->get_field_id( 'handle' ); ?>" name="<?php echo $this->get_field_name( 'handle' ); ?>" type="text" value="<?php echo esc_attr( $handle ); ?>" />
		
		<?php 
	 
			if( $handle  ){
				if (!preg_match('/^@[a-zA-Z0-9]+(?:\.[a-zA-Z0-9]+)*$/', $handle)) {
				echo '
				<div class="handle_error">A handle needs to begin with @ and may only contain numbers and Latin letters, optionally separated by a dot (.)</div>
				';
					}
			}
			if( $handle === '' ){
				echo '
				<div class="handle_error">Please enter a valid Gruveo handle.</div>
				';
			}
		?>
		 
		<div class="subtext">Don't have a Gruveo handle yet? <a href="https://www.gruveo.com/user/signup" target="_blank">Click here</a> to get one.</div>
		</p>
		
		 
		
		
		<p>
		<div class="marg_bottom_5" for="<?php echo $this->get_field_id( 'button_type' ); ?>"><?php _e( 'Button type:' ); ?></div> 
		
		<div class="marg_bottom_5"><label><input type="radio" id="<?php echo $this->get_field_id( 'button_type' ); ?>" name="<?php echo $this->get_field_name( 'button_type' ); ?>" value="video" <?php if( ( esc_attr( $button_type ) == 'video' ) || ( !$button_type && !$handle ) ) echo ' checked ';  ?> ><?php _e('Video call') ?></label></div>	
		
 
		<div class="marg_bottom_5"><label><input type="radio" id="<?php echo $this->get_field_id( 'button_type' ); ?>" name="<?php echo $this->get_field_name( 'button_type' ); ?>" value="voice" <?php if( esc_attr( $button_type ) == 'voice' || ( !$button_type && $handle )  ) echo ' checked ';  ?> ><?php _e('Voice call') ?></label></div>
		
		</p>
		<p>
		<label for="<?php echo $this->get_field_id( 'button_size' ); ?>"><?php _e( 'Button size:' ); ?></label> 
		<select class="widefat" id="<?php echo $this->get_field_id( 'button_size' ); ?>" name="<?php echo $this->get_field_name( 'button_size' ); ?>">

			<option value="regular" <?php if( esc_attr( $button_size ) == 'regular' ) echo ' selected ';  ?> ><?php _e('Small') ?>
			<option value="large" <?php if( esc_attr( $button_size ) == 'large' || (  $button_size == '' && $large_button == 'on' ) ) echo ' selected ';  ?> ><?php _e('Large') ?>
			<option value="xlarge" <?php if( esc_attr( $button_size ) == 'xlarge' ) echo ' selected ';  ?> ><?php _e('Extra large') ?>
		</select>
		</p>
		
		
	 
		
		<p>
		<label for="<?php echo $this->get_field_id( 'language' ); ?>"><?php _e( 'Language:' ); ?></label> 
		<select class="widefat" id="<?php echo $this->get_field_id( 'language' ); ?>" name="<?php echo $this->get_field_name( 'language' ); ?>">
			<option value="">Detect automaticaly
			<option value="en" <?php if( esc_attr( $language ) == 'en' ) echo ' selected ';  ?> >English
			<option value="de" <?php if( esc_attr( $language ) == 'de' ) echo ' selected ';  ?> >Deutsch
			<option value="es" <?php if( esc_attr( $language ) == 'es' ) echo ' selected ';  ?> >Español
		</select>
		</p>
		
		<?php 
	}

} // class Foo_Widget
// register Foo_Widget widget
add_action( 
	'widgets_init', 
	function () { 
		return register_widget( "gruveo_widget" );
	}
);

?>
